<?php
namespace Teknisa\TCO\Authentication;

use Zeedhi\Framework\DTO\Response as DTO_Reponse;
use Zeedhi\Framework\HTTP\Response as HTTP_Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\ExceptionHandler\ExceptionHandler as ZeedhiExceptionHandler;

class ExceptionHandler implements ZeedhiExceptionHandler{
    /**
     * Exceptions that this class can handle
     * with.
     */
    protected $handledExceptions = array(
        'Teknisa\TCO\Authentication\Exception'
    );
    
    /**
     * Set a new error at reponse with the
     * exception message.
     */
    public function handleException(\Exception $exception, DTO_Reponse $response){
        $exceptionMessage = $exception->getMessage();
        $response->setStatus(HTTP_Response::HTTP_INTERNAL_SERVER_ERROR);
        $response->setError(new Error($exceptionMessage, $exception->getCode(), $exception->getTraceAsString()));
    }

    /**
     * Returns the handledExceptions list.
     */
    public function getHandledExceptionClasses(){
        return $this->handledExceptions;
    }
}